//	Listener.cpp - Sample application for CSerial
//
//	Copyright (C) 1999-2003 Ramon de Klein (Ramon.de.Klein@ict.nl)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#define STRICT
#include <tchar.h>
#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <time.h>
#include <string.h>
#include "Serial.h"

enum { EOF_Char = 27 };


//JF: Definicion de tamaos de encabezados y finales de trama maximos del RotoScan

#define MAX_INFO                  529 // Datos de medicion maximos de usuario que se pueden leer
#define MAX_TRAMA                 1081// Numero de caracteres  maximos en el paquete del RS4 to PC
#define Tam_End                  4 // 3 0x00,0x00,0x00 and check character
#define Tam_Hea_Info			 13// 2 bytes output stop,2 bytes output start, 1 resolution and 8 num_scan   	
#define Tam_Hea_Paq              6 // 3 bytes option (?), 1 byte command and 2 bytes start

#define ALLONES					65.0  // All ones corresponds to 65 meters
#define TWOTOTHE15				32768.0 // 2^15

struct Datos_RS4{ 

int resolution;
long output_start;
long output_stop;
long Num_max_char;
long Tam_info;


unsigned char unbyte;
long limit_k;


/*JF: En este arreglo se gurdan todos los caracteres deducidos de la trama del RS4*/
unsigned char mensaje[MAX_TRAMA]; // tamao del paquete del protocolo del RS4
/*JF: Arreglo donde se gurdan los datos del contorno */
float contourjf[MAX_INFO]; 

};




int ShowError (LONG lError, LPCTSTR lptszMessage)
{
	// Generate a message text
	TCHAR tszMessage[256];
	wsprintf(tszMessage,_T("%s\n(error code %d)"), lptszMessage, lError);

	// Display message-box and return with an error-code
	::MessageBox(0,tszMessage,_T("Listener"), MB_ICONSTOP|MB_OK);
	return 1;
}


int __cdecl _tmain (int /*argc*/, char** /*argv*/)
{
    CSerial serial;
	LONG    lLastError = ERROR_SUCCESS;

	//char reserva[200];
	//char cadena[200];
	char szBuffer[1];
	int u=0,b_res=0, pos=0 ;
	BOOL F_INI = 0, F_RES=0; // Primer=TRUE;
	clock_t t1,t2;
	 double tot;

	Datos_RS4 data={1};

	COMSTAT COMstatus;
	int NumCharsAvail,contados=0,leidos=0;
	DWORD  dwBytesRead = 0;
	DWORD ErrCode;
	char err;


    // Attempt to open the serial port (COM2)
    lLastError = serial.Open(_T("COM2"),0,0,false);
	if (lLastError != ERROR_SUCCESS)
		return ::ShowError(serial.GetLastError(), _T("Unable to open COM2-port"));

    // Setup the serial port (57600,8N1, which is the default setting)
    lLastError = serial.Setup(CSerial::EBaud57600,CSerial::EData8,CSerial::EParNone,CSerial::EStop1);
	if (lLastError != ERROR_SUCCESS)
		return ::ShowError(serial.GetLastError(), _T("Unable to set COM-port setting"));

    // Register only for the receive event
    lLastError = serial.SetMask(CSerial::EEventBreak |
								CSerial::EEventCTS   |
								CSerial::EEventDSR   |
								CSerial::EEventError |
								CSerial::EEventRing  |
								CSerial::EEventRLSD  |
								CSerial::EEventRecv);
	if (lLastError != ERROR_SUCCESS)
		return ::ShowError(serial.GetLastError(), _T("Unable to set COM-port event mask"));

	// Use 'non-blocking' reads, because we don't know how many bytes
	// will be received. This is normally the most convenient mode
	// (and also the default mode for reading data).
    lLastError = serial.SetupReadTimeouts(CSerial::EReadTimeoutNonblocking);
	if (lLastError != ERROR_SUCCESS)
		return ::ShowError(serial.GetLastError(), _T("Unable to set COM-port read timeout."));

    

	/*Mantener leyendo eventos hasta que, se presiona el teclado*/
	printf("Todo bien por ahora!!\n");
	printf("Presione una tecla para salir: \n");
	serial.Purge();
	t1=clock();

	do
	{
		// Wait for an event

		lLastError = serial.WaitEvent();
		if (lLastError != ERROR_SUCCESS)
			return ::ShowError(serial.GetLastError(), _T("Unable to wait for a COM-port event."));

		// Save event
		const CSerial::EEvent eEvent = serial.GetEventType();

		// Handle break event
		if (eEvent & CSerial::EEventBreak)
		{
			printf("\n### BREAK received ###\n");
		}

		// Handle CTS event
		if (eEvent & CSerial::EEventCTS)
		{
			printf("\n### Clear to send %s ###\n", serial.GetCTS()?"on":"off");
		}

		// Handle DSR event
		if (eEvent & CSerial::EEventDSR)
		{
			printf("\n### Data set ready %s ###\n", serial.GetDSR()?"on":"off");
		}

		// Handle error event
		if (eEvent & CSerial::EEventError)
		{
			printf("\n### ERROR: ");
			switch (serial.GetError())
			{
			case CSerial::EErrorBreak:		printf("Break condition");			break;
			case CSerial::EErrorFrame:		printf("Framing error");			break;
			case CSerial::EErrorIOE:		printf("IO device error");			break;
			case CSerial::EErrorMode:		printf("Unsupported mode");			break;
			case CSerial::EErrorOverrun:	printf("Buffer overrun");			break;
			case CSerial::EErrorRxOver:		printf("Input buffer overflow");	break;
			case CSerial::EErrorParity:		printf("Input parity error");		break;
			case CSerial::EErrorTxFull:		printf("Output buffer full");		break;
			default:						printf("Unknown");					break;
			}
			printf(" ###\n");
		}

		// Handle ring event
		if (eEvent & CSerial::EEventRing)
		{
			printf("\n### RING ###\n");
		}

		// Handle RLSD/CD event
		if (eEvent & CSerial::EEventRLSD)
		{
			printf("\n### RLSD/CD %s ###\n", serial.GetRLSD()?"on":"off");
		}

		// Handle data receive event
		if (eEvent & CSerial::EEventRecv)
		{
		//********************PRIMER BLOQUE FUNCIONAL**********************
		//Lectura de la trama.
        //*****************************************************************
		//Una vez se atiende el evento:El primer paso es saber cuantos
		//Bytes hay disponibles en el puerto, eso se puede lograr llamando
		//a la funcion ClearCommError.
		err = ClearCommError(serial.GetCommHandle(), &ErrCode, &COMstatus);
			if (err == FALSE) 
			{
				printf("\nERROR!(SerialBytesIn): ClearCommError error (%d)\n", GetLastError() );
				return(FALSE);
			}
		NumCharsAvail = (int)COMstatus.cbInQue;
		//Opcional: se lleva el conteo de los bytes disponibles cada vez que se genera el evento
		contados=contados+NumCharsAvail;
		int i=0;

		//Segunda parte: Se contabilizan los bytes disponibles y si son mayores de cero	
		//se realiza su lectura hasta que no hayan bytes para leer
        
		if(NumCharsAvail>0)
		{
		    do
			{
			 // Se lee un Byte del puerto ciclicamente
			 lLastError = serial.Read(szBuffer,1,&dwBytesRead);
		     if (lLastError != ERROR_SUCCESS) 	return ::ShowError(serial.GetLastError(), _T("Unable to read from COM-port."));
			 //Se procesa el Byte leido solo si el numero de bytes leidos es diferente de cero
			 if(dwBytesRead) 
				{
				//En el buffer cadena se guarda el byte leido
				//pero mientras el sistema se sincroniza no guarda...
			    if(F_INI){
						data.mensaje[pos]=szBuffer[0];
						pos++;
						}
				//Se monitorea el final de la trama
				if(szBuffer[0]==0) 
						{
						u+=1;
						if(u==3){
							//printf("Fin de trama detectado! En la posicion :%d %d\n",i,NumCharsAvail);
							F_RES=1;
							b_res=pos;
							pos=0;
							}
						}
				else u=0;
				i++;
				}
			}while(dwBytesRead);
			
		}  
		
        leidos=leidos +i;
		//
		//
	    //
		if(F_RES && F_INI) 
			{
			
			t2=clock();
			tot=(double)(t2-t1) / CLOCKS_PER_SEC;
			printf( "Contados, leidos %d %d %s %2.0f ms\n", contados,leidos,"en Duracion del evento: ",tot*1000);
			//printf("Comando :%x %s %d \n",data.mensaje[16],"Posicion final",b_res); 
			//printf("%d  %d\n", F_RES,F_INI);
			t1=clock();
			contados=0;
			leidos=0;
			F_RES=FALSE;

				
		//Una vez la trama completa se guarda se debe obtener la configuracion. 
        //********************SEGUNDO BLOQUE FUNCIONAL**********************
		//Informacion de la configuracion de la trama.
        //*****************************************************************
		{
		int Thp=0, Pos_res=0, Tam_Inf=0;
		//unsigned char anByte;
		char start_a,start_b,stop_a,stop_b;//,err;
		//se obtiene la configuracion presente en la trama
		//primero se toman los valores limites dados en la trama

		//Se guarda el limite llegado por el contador de lectura de bytes
		data.limit_k=b_res-1;

		//1.De acuerdo al numero de campos de opcion se lee
		//la resolucion, segmento de start y de stop
		Thp = data.mensaje[3] & 3;
		if(Thp>3) return ::ShowError(serial.GetLastError(), _T("Error en el campo Opcion.")); //Error en la sincronizacion
			  else Pos_res=Thp+11;
	 
        data.resolution=data.mensaje[Pos_res];
		start_b=data.mensaje[Pos_res+1];
		start_a=data.mensaje[Pos_res+2];
		stop_b=data.mensaje[Pos_res+3];
		stop_a=data.mensaje[Pos_res+4];
		
		//2: Calculo de limites del campo de info y Num Max de Char el valor de b_res
		//es el ultimo valor de pos, osea el tamao total en bytes de la trama.
		//El valor 3-Thp, es en el caso de que el campo de opcion sea diferente de 3.

		data.Tam_info=(b_res-Tam_End-Tam_Hea_Info-(Tam_Hea_Paq -3 + Thp));
		data.Num_max_char=Tam_End + data.Tam_info + Tam_Hea_Info + ((Tam_Hea_Paq -3 + Thp)-2);

		//3: Comparacion con los valores limites tomados de la trama:
		data.output_start=(int)(256*(int)start_b + (int)start_a);
		data.output_stop=(int)(256*(int)stop_b + (int)stop_a);
		Tam_Inf=((data.output_stop-data.output_start)/data.resolution)+1;

		if(Tam_Inf*2 > data.Tam_info) //Error en la sincronizacion
		{
		printf("Tam_Info y data.Tam_info %d %d\n",Tam_Inf,(data.Tam_info)/2);
		return ::ShowError(serial.GetLastError(), _T("Error de Sincronizacion, en los tamaos del campo de informacion."));
		} 
		//4: Impresion de la configuracion del RS4
		printf("\n\n***Configuracion del RS4****\n");
		printf("Segmento Inicial (1 EQU -5,36 Grados): %d \n",data.output_start);
		printf("Segmento Final (529 EQU 185 Grados): %d\n",data.output_stop);
		printf("Mediciones tomadas: %d\n",data.Tam_info);
		printf("Resolucion (1 EQU 0,36 Grados) : %d\n",data.resolution);
				
		}//del codigo de obtencion de la configuracion de la trama
		//*******************************************************************
		{
		//Una vez se obtiene la configuracion se procesa la info del usuario
        //********************TERCER BLOQUE FUNCIONAL**********************
		//Procesamiento de la informacion de usuario.
        //*****************************************************************		

		float Cte;
    
	
	
		//version JF:
		Cte=ALLONES/TWOTOTHE15; //Expresion para convertir a metros la distancia. 
		for(int l=0;l<(data.Tam_info/2);l++)
		{
		/* Los datos se guardan hacia atras,desde el 529 al 1.
	       Se empieza en cuatro por los tres tokens 0x00 de fin de cadena despues del
		   caracter de chequeo. Se inicia desde atras del paquete a recuperar los datos.
		   256 * mensaje(limit_k-4-(2*l+1)) corresponde al byte mas significativo 
		         mensaje(limit:k-4-2*1)/2  corresponde al byte menos significativo    
		   Division por dos de toda la expresion para eliminar el bit menos significativo del LSB    */
		data.contourjf[l]=(float) ( Cte*(int)((256*(int)data.mensaje[(data.limit_k)-4 -(2*l+1)]+(int)data.mensaje[(data.limit_k)-4-2*l])/2 ) );
		}
		//printf("El valor limite del contador del maximo valor es: %d\n",*tam_info-1);
	
		printf("Medi No. 0 y No %d %s %f %f\n\n",data.Tam_info/2-1,":",data.contourjf[data.Tam_info/2-1],data.contourjf[0]);


		}//del codigo de procesmiento de la info del usuario.
		//*******************************************************************
		
		}// del If(F_RES)							*/

		//Esta linea tiene como proposito que durante la sincronizacion 
		//F_INI ==FALSE no se procesen los datos de la trama
		if((F_INI==0) && (F_RES==1)) {F_INI=1;F_RES=0;}

	}// del manejador del evento
	}while(!kbhit());/*while (fContinue);*/

	printf("Presione s para salir....\n");
	for(;;){ if(getch()=='s') break;}
    
    // Close the port again
    serial.Close();
    return 0;
}
